#ifndef __TCOMUPSAMPLEFILTER__
#define __TCOMUPSAMPLEFILTER__

#include "TComPic.h"
#include "TComYuv.h"
#include "TComDataCU.h"

#define NTAPS_US_LUMA        8 ///< Number of taps for luma upsampling filter
#define NTAPS_US_CHROMA      4 ///< Number of taps for chroma upsampling filter
#define US_FILTER_PREC    6 ///< Log2 of sum of filter taps

class TComUpsampleFilter
{
private:
  static const Int m_iFilter16_luma_fixed[12][NTAPS_US_LUMA];     ///< Luma filter taps
  static const Int m_iFilter16_chroma_fixed[12][NTAPS_US_CHROMA]; ///< Chroma filter taps

  Pel m_tempBuffer[(MAX_CU_SIZE + 2*NTAPS_US_LUMA) * (MAX_CU_SIZE + 2*NTAPS_US_LUMA)];

  Int m_iFilter16_luma[16][NTAPS_US_LUMA];
  Int m_iFilter16_chroma[16][NTAPS_US_CHROMA];

public:
  TComUpsampleFilter(void);
  ~TComUpsampleFilter(void);

 Void upsampleBasePic( TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic );
};

#endif //__TCOMUPSAMPLEFILTER__
